; _Ps Codice

; Include "HJConst.JSH"; file costanti predefinito di Jaws
Include "_PsConst.JSH"; File personale delle costanti
Include "_PsGlobals.JSH"; file personale delle variabili globali
Include "_PsMessages.JSM"; File personale dei messaggi

Script InserisceFirma ()
MetteTesto (INIZIO_PERSONALE, RIGA_VUOTA); invia l'etichetta Personale alla funzione
EndScript

Script MuoveElementoSuccessivo ()
{F2}; richiama il comando originale
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
EndScript

Script MuoveElementoPrecedente ()
{Shift+F2}; richiama il comando originale
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
EndScript

Script TrovaTesto ()
SpeechOff (); spegne la sintesi
PerformScript SalvaContrassegno (); esegue lo script per salvare la posizione del cursore
SpeechOn (); riattiva la sintesi
TypeCurrentScriptKey (); passa i tasti premuti all'applicazione
EndScript

Script SelezionaDalContrassegno ()
SelectFromSavedLocationToCurrent (); attiva la selezione
EndScript

Script SalvaContrassegno ()
SayString ("Percorso salvato"); annuncia il comando
SaveCurrentLocation (); registra la posizione del cursore
EndScript

Script SostituisceTesto ()
TypeCurrentScriptKey (); ripete i tasti di attivazione dello script
EndScript

Script DataOra ()
Var
Int iOre, ; ore rimanenti alla mezzanotte
Int iMinuti, ; minuti mancanti all'ora successiva
String sOre; messaggio testuale sul tempo rimanente

SayMessage (OT_ERROR, SysGetDate (msgDataEstesa)); pronuncia la data,
SayMessage (OT_ERROR, SysGetTime (msgOraEstesa)); e legge anche l'orario
Let iOre = 24 - (StringToInt (SysGetTime ("H")) + 1); calcola le ore alla mezzanotte,
Let iMinuti = 60 - StringToInt (SysGetTime ("m")); poi calcola anche i minuti rimanenti
Let sOre = FormatString ( ; compone il messaggio, specificando:
msgMezzanotte, ; parametro1, il messaggio creato con i due segnaposti numerati,
iOre, ; parametro2, il dato sulle ore, da sostituire al segnaposto %1,
iMinuti); parametro3, il dato sui minuti, da sostituire al segnaposto %2
SayMessage (OT_ERROR, sOre); legge il messaggio formattato
EndScript

Script AvviaCronometro ()
Var String sMessaggio; l'avviso formattato
Let gnTempoIniziale = GetTickCount (); registra i millisecondi trascorsi dall'avvio
Let sMessaggio = FormatString ( ; formatta l'avviso da leggere
msgOraAvvio, ; parametro1, il messaggio base
SysGetTime ()); parametro2, l'ora da inserire nell'avviso
SayMessage (OT_ERROR, sMessaggio); legge l'avviso formattato
Beep (); emette un segnale acustico
EndScript

Script TempoTrascorso ()
Var
Int iValore, ; il tempo trascorso in millisecondi
Int iSecondi, ; i secondi trascorsi
String sUltimaParte, ; la parte finale dei millisecondi convertiti in testo
String sCentesimi, ; la stringa con i centesimi di secondo
Int iMinuti, ; numero dei minuti trascorsi
Int iOre; numero delle ore trascorse

Let iValore = GetTickCount () - gnTempoIniziale; sottrae il tempo di partenza all'attuale
Let iSecondi = iValore / 1000; converte il valore in secondi
Let sUltimaParte = StringRight (IntToString (iValore), 3); estrae le tre cifre a destra
Let sCentesimi = StringLeft (sUltimaParte, 2); preleva le prime due cifre a sinistra
If iSecondi < MINUTO Then; se il tempo trascorso  inferiore al minuto, legge l'avviso
SayFormattedMessage (OT_HELP, msgBaseTempo, NULLO, iSecondi, sCentesimi)
ElIf iSecondi < ORA Then; se invece siamo sotto all'ora,
Let iMinuti = iSecondi / MINUTO; calcola i minuti trascorsi,
Let iSecondi = iSecondi - (iMinuti * MINUTO); sottrae ai secondi quelli relativi ai minuti,
SayFormattedMessage (OT_HELP, msgMinuti, NULLO, iMinuti, iSecondi, sCentesimi);
Else; se invece siamo sopra all'ora di tempo trascorso,
Let iOre = iSecondi / ORA; calcola le ore trascorse suddividendo i secondi,
; quindi calcola i minuti dividendo i secondi rimasti dopo aver tolto quelli delle ore,
Let iMinuti = (iSecondi - (iOre * ORA)) / MINUTO
; e infine aggiorna i secondi togliendo quelli compresi nelle ore e nei minuti
Let iSecondi = iSecondi - ((iOre * ORA) + (iMinuti * MINUTO))
SayFormattedMessage (OT_HELP, msgOre, NULLO, iOre, iMinuti, iSecondi); legge l'avviso
EndIf; fine controllo tempo
EndScript

Script Saluto ()
Var
Int iOra, ; ora corrente
Int iValore; dato da estrarre

Let iOra = StringToInt (SysGetTime (_H)); rileva l'ora corrente
If iOra >= MATTINO && iOra < POMERIGGIO Then; se si  nel mattino,
Let iValore = 1; imposta il numero del dato da estrarre
ElIf iOra >= POMERIGGIO && iOra < SERA Then; se invece si  nel pomeriggio,
Let iValore = 2; imposta il dato relativo
ElIf iOra >= SERA && iOra < NOTTE Then; se si  in orario serale,
Let iValore = 3; imposta il dato
ElIf iOra >= NOTTE || iOra < MATTINO Then; se infine si  nell'orario notturno,
Let iValore = 4; imposta il dato
EndIf; fine controllo ora corrente
SayMessage (OT_HELP, StringSegment (lstSaluti, PIPE, iValore)); legge il saluto estratto
EndScript

Script CopiaRiga ()
If !StringTrimLeadingBlanks (GetLine ()) Then; se nella riga non  presente del testo,
SayMessage (OT_HELP, msgRigaVuota, msgRigaVuota_corto); avvisa dell'errore,
Return; e interrompe il flusso
EndIf; fine controllo riga corrente
SpeechOff (); spegne la sintesi
JAWSEnd (); porta il cursore a fine riga
SelectFromStartOfLine (); seleziona la riga corrente
SpeechOn (); riattiva la sintesi
Refresh (); resetta la schermata
PerformScript CopySelectedTextToClipboard (); esegue lo script nativo
EndScript

Script AggiungeRiga ()
If !StringTrimLeadingBlanks (GetLine ()) Then; se nella riga non  presente del testo,
SayMessage (OT_HELP, msgRigaVuota, msgRigaVuota_corto); avvisa dell'errore,
Return; e interrompe il flusso
EndIf; fine controllo riga corrente
SpeechOff (); spegne la sintesi
JAWSEnd (); porta il cursore a fine riga
SelectFromStartOfLine (); seleziona la riga corrente
SpeechOn (); riattiva la sintesi
Refresh (); resetta la schermata
PerformScript AppendSelectedTextToClipboard (); esegue lo script nativo
EndScript

Script AperturaCodice ()
MetteTesto (lstApreScript, RIGA_VUOTA); invia le dichiarazioni di apertura alla funzione
EndScript

Int Function SceltaLivello ()
Return DlgSelectItemInList (; restituisce la scelta effettuata
VociScelta (), ; parametro1, la nostra funzione che compone le voci di scelta
FormatString (ttlSelezione, ttlLivelloFinestra, gsNomeFinestra), ; parametro2, testo a video
FALSE); parametro3, valore per disattivare l'ordinamento alfabetico
EndFunction

Handle Function LivelloFinestra (int iLivello)
If iLivello == CORRENTE Then; se stata scelta la prima voce,
Return GetCurrentWindow (); restituisce l'Handle della finestra corrente
ElIf iLivello == REALE Then; se invece si  scelta la seconda voce,
Return GetRealWindow (GetFocus ()); restituisce l'Handle per la prima finestra col titolo
ElIf iLivello == PRINCIPALE Then; Se invece  stata scelta l'ultima voce,
Return GetAppMainWindow (GetFocus ()); restituisce l'Handle della finestra Principale
EndIf; fine controllo livello
EndFunction

Script InfoFinestra ()

Var
int iScelta, ; scelta effettuata
Handle h, ; finestra da leggere
String sLivello, ; livello della finestra
String sInfo; testo del messaggio

Let gsNomeFinestra = NULLO; azzera l'eventuale valore impostato
Let iScelta = SceltaLivello (); imposta il livello della finestra di cui leggere i dati

If !iScelta Then; nel caso la variabile sia 0, essendo stato premuto il tasto Esc o Annulla,
Return; interrompe lo script
EndIf; fine controllo annullamento

Let h = LivelloFinestra (iScelta); imposta l'Handle, sulla base del livello appena scelto

; estrae il nome del livello della finestra e lo imposta nella variabile
Let sLivello = StringSegment (lstLivelliFinestra, PIPE, iScelta)

Let sInfo = FormatString ( ; crea il testo da visualizzare mettendo i dati nei segnaposto
msgDatiFinestra, ; parametro1, nome del messaggio base
sLivello, ; parametro2, testo della voce scelta, al posto di %1,
h, ; parametro3, Handle, al posto di %2
GetControlID (h), ; parametro4, Control ID, al posto di %3
GetWindowName (h), ; parametro5, nome della finestra, al posto di %4
GetWindowType (h), ; parametro6, tipo della finestra, al posto di %5
GetWindowTypeCode (h), ; parametro 7, codice di tipo, al posto di %6
GetWindowSubtypeCode (h), ; parametro 8, codice di Sottotipo, al posto di %7
GetWindowClass (h), ; parametro9, classe della finestra, al posto di %8
hlpFineInfo); parametro10, formula di fine informazioni, al posto di %9

SayMessage (OT_USER_BUFFER, sInfo); invia i dati al Visualizzatore Virtuale

EndScript

String Function CodiceFinestra (int iLivello)
Var Handle h; l'Handle della finestra

Let h = LivelloFinestra (iLivello); determina l'Handle sulla base del livello indicato
If iLivello == CORRENTE Then; se si  richiesto un codice del primo tipo,
Return FormatString ( ; restituisce un messaggio formattato con tre termini
msg3Trattino, ; parametro1, messaggio base con tre segnaposti
GetWindowTypeCode (h), ; parametro2, codice di tipo, al posto di %1
GetWindowSubtypeCode (h), ;parametro3, codice di Sottotipo, al posto di %2
GetWindowClass (h));parametro4, classe della finestra al posto di %3.
ElIf iLivello == REALE ; Se invece si  scelto il livello Reale,
|| iLivello == PRINCIPALE Then; oppure quello principale,
Return FormatString ( ; restituisce un messaggio formattato con due soli termini
msg2Trattino, ; parametro1, messaggio base con due segnaposti
GetWindowName (h), ; parametro2, nome della finestra da mettere al posto di %1
GetWindowClass (h));parametro3, classe della finestra al posto di %2.
EndIf; fine controllo livello
EndFunction

String Function VociScelta ()
Var
Int i, ; contatore del ciclo
String sVoci, ; elenco da restituire
String sNome; nome del livello di finestra

Delay (ATTESA); sospende il flusso per i decimi di secondo impostati
For i = 1 To StringSegmentCount (lstLivelliFinestra, PIPE); scorre le voci nella stringa
If i > 1 Then; se si  dal secondo passaggio in poi,
Let sVoci = sVoci + BELL; inserisce il separatore delle voci
EndIf; fine controllo passaggi
Let sNome = StringSegment (lstLivelliFinestra, PIPE, i); estrae la prima parte della voce
Let sVoci = sVoci + FormatString (msg2Punto, sNome, CodiceFinestra (i)); accoda il codice
EndFor; fine ciclo di scansione livelli
Return sVoci; restituisce l'elenco ricostruito
EndFunction

Void Function MetteTesto (string sDati, int iRitorni)
If CodiceFinestra (CORRENTE) != CODICE_EDITOR Then; se la finestra non  corretta,
TypeCurrentScriptKey (); ripristina i tasti premuti,
Return; e interrompe il flusso
EndIf; fine controllo finestra
Var
Int i, ; contatore del ciclo
Int iRighe, ; numero delle righe copiate
String sRiga; singolo segmento da scrivere

SpeechOff (); spegne la sintesi
; rimuove dal testo eventuali caratteri di ritorno a capo, Ascii 13
Let sDati = StringReplaceSubstrings (sDati, CR, NULLO)
; esegue un ciclo, ripetendolo per il numero di segmenti nella stringa
For i = 1 To StringSegmentCount (sDati, LF)
If i > 1 Then; dal secondo passaggio in poi,
EnterKey (); simula la pressione di Invio, per creare una nuova riga
Let iRighe = iRighe + 1; aggiorna il contatore delle righe copiate
Pause (); sospende momentaneamente il flusso
EndIf; fine controllo passaggi
Let sRiga = StringSegment (sDati, LF, i); estrae il segmento equivalente ad una riga,
TypeString (sRiga); e lo trascrive nel documento
EndFor; fine ciclo scansione testo
If StringRight (sDati, 1) == LF Then; se l'ultimo carattere del testo  quello di nuova linea,
Let iRitorni = iRitorni + 1; aggiunge una unit ai ritorni a capo da creare
EndIf; fine controllo ultimo carattere
For i = 1 To iRitorni; aggiunge eventuali o ulteriori ritorni a capo
EnterKey (); crea un'ulteriore nuova riga
Let iRighe = iRighe + 1; aggiorna il contatore delle righe copiate
EndFor; fine ciclo ritorni a capo
SpeechOn (); riattiva la sintesi
If iRighe Then; se sono state copiate delle righe intere,
If iRighe > 1 Then; se le righe sono pi di una,
Let sDati =FormatString (msgMettiRighe, iRighe); formatta il dato con il numero di righe
EndIf; fine controllo numero righe
SayMessage (OT_ERROR, sDati); legge il messaggio in tono minore
EndIf; fine controllo righe copiate
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
EndFunction

String Function Nota (int iValore)
Var Int iBase; aggiunta per conversione in lettera
If iValore <= 5 Then; se le note sono fino al Sol,
Let iBase = INIZIO_C; imposta una base per lettere dalla C alla G
Else; altrimenti, se sono note dal La al Do alto,
Let iBase = INIZIO_A; imposta una base per lettere dalla A alla C
EndIf; fine impostazione base
; restituisce il nome del file, opportunamente formattato
Return FormatString (lstFileNote, iValore, MakeCharacterFromValue (iBase + iValore))
EndFunction

Void Function Suona (string sFile, int iRitardo)
PlaySound (FindJAWSSoundFile (sFile)); suona il file di suoni specificato
Delay (iRitardo); sospende il flusso per i decimi di secondo specificati
EndFunction

Script FraMartino ()
Var
Int iTempo1, ; primo intervallo di tempo
Int iTempo2, ; secondo intervallo di tempo
Int i; contatore dei cicli
Let iTempo1 = 4; imposta il valore intero
Let iTempo2 = 2; imposta un tempo dimezzato
For i = 1 To 2; esegue le prime due battute
Suona (Nota (1), iTempo1)
Suona (Nota (2), iTempo1)
Suona (Nota (3), iTempo1)
Suona (Nota (1), iTempo1)
EndFor; fine prime due battute
For i = 1 To 2; esegue terza e quarta battuta
Suona (Nota (3), iTempo1)
Suona (Nota (4), iTempo1)
Suona (Nota (5), iTempo1)
Delay (iTempo1)
EndFor; fine terza e quarta battuta
For i = 1 To 2; esegue quinta e sesta battuta
Suona (Nota (5), iTempo2)
Suona (Nota (6), iTempo2)
Suona (Nota (5), iTempo2)
Suona (Nota (4), iTempo2)
Suona (Nota (3), iTempo2)
Delay (iTempo2)
Suona (Nota (1), iTempo2)
Delay (iTempo2)
EndFor; fine quinta e sesta battuta
For i = 1 To 2; esegue penultima ed ultima battuta
Suona (Nota (2), iTempo1)
Suona (Nota (5), iTempo1)
Suona (Nota (1), iTempo1)
Delay (iTempo1)
EndFor; fine penultima e ultima battuta
EndScript

